//
//  Header.h
//  tap_rec
//
//  Created by Jeffrey Harriman on 3/11/12.
//  Copyright (c) 2012 Stanford University. All rights reserved.
//

#ifndef tap_rec_ChordTrack_h
#define tap_rec_ChordTrack_h
#include "Track.h"
#include "LeadTrack.h"

class ChordTrack : public Track{
    
    LeadTrack ** m_voices;
    int m_numVoices;
    int m_rootDegree;
    
public:
    ChordTrack();
    ~ChordTrack();
    
    SAMPLE tick(int frame);
    
    void setScaleDegree(int scaleDegree);
    void setMaj(int scaleDegree);
    void setMin(int scaleDegree);
    void setDim(int scaleDegree);
    void setChord(int root, int third, int fifth);

    CHORD getChord();
    int getScaleDegree(){return m_rootDegree;};    
    
    void playChordData();
    int convertScaleDegree(int note);

};

#endif
