//
//  LeadTrack.cpp
//  tap_rec
//
//  Created by Jeffrey Harriman on 3/10/12.
//  Copyright (c) 2012 Stanford University. All rights reserved.
//

#include <iostream>
#include "LeadTrack.h"

LeadTrack::LeadTrack():MonophonicTrack(){
    m_synth = new stk::Blit();
    m_synth->setHarmonics(7);
}

SAMPLE LeadTrack::tick(int frame){
    
//    if (m_playMode == STANDBY || m_playMode == RECORD || m_playMode == LOOP){
//        m_synth->setFrequency( m_portamento->tick(m_freq) );
//        return (m_adsr->tick() * m_synth->tick());
//    }
    if (m_playMode == PLAY || m_playMode == LOOP)
    {
        if (m_metronome->beginningOfBeat(frame))
            playArticulation();
    }
    
    if (m_playMode == PLAY || m_playMode == RECORD_ARTICULATION)
    {
        m_ptr++;
        if (m_ptr >= m_length){
            setPlayMode(PLAY);
            m_metronome->setActive(false);
        }
        
        playNoteData();
    }
    else if (m_playMode == RECORD)
    {
        m_ptr++;
        if (m_ptr >= m_length){
            setPlayMode(PLAY);
            m_metronome->setActive(false);
        }
    }
    m_synth->setFrequency( m_portamento->tick(m_freq) );
    return (m_adsr->tick() * m_synth->tick());

}