//
//  Metro.h
//  seq
//
//  Created by Jeffrey Harriman on 2/27/12.
//  Copyright (c) 2012 Stanford University. All rights reserved.
//

#ifndef seq_Metro_h
#define seq_Metro_h

#import "JifDefines.h"
#import "mo_def.h"
#import "ResonantLowPass.h"

#import "ADSR.h"

class Metro {
    bool m_on;

    float m_tempo;
    int m_numBeats;
    int m_subDiv;
    int m_numMeasures;
    
    int m_beatCount;
    int m_subCount;
    int m_measureCount;
    int m_sampleCount;
    int m_beatLengthInSamples;
    
    ResonantLowPass * m_resFilt;
    stk::ADSR * m_adsr;
    
public:
    Metro();
    ~Metro(){};
    
    SAMPLE tick();
    void stop();
    void setTempo(float newTempo);
    void setNumBeats(int beats){m_numBeats = beats;};
    void setNumMeasures(int measures){m_numMeasures = measures;};
    void setBeatDiv(int beatDiv){m_subDiv = beatDiv;};
    void setActive(bool on){m_on = on;};
    void setTimeZero();
    void startCountIn();
    
    int getBeatCount(){return m_beatCount;};
    int getSampleCount(){return m_sampleCount;}
    int getBeatLengthInSamples(){return m_beatLengthInSamples;};
    int getNumBeats(){return m_numBeats;};
    int getLoopLength(){return m_numBeats * m_numMeasures * m_subDiv * m_beatLengthInSamples;};
    bool getCountIn(){return m_countIn;};
    bool beginningOfLoop();
    bool beginningOfBeat(int frame);
    BEAT_COUNT getQuantizedBeat();
    
    // public vars
    bool m_countIn;
};

#endif
