//
//  ModalTest.m
//  Wreck Chord
//
//  Created by Jeffrey Harriman on 3/13/12.
//  Copyright (c) 2012 Stanford University. All rights reserved.
//

#import "ModalTest.h"
#import "SongShareClient.h"
#import "mo_def.h"
#import "SSSViewController.h"

@implementation ModalTest
@synthesize soundTableView;
@synthesize sounds;
@synthesize mainView;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (void)getSoundAtURL:(NSURL *)url
{
    NSData *data = [NSData dataWithContentsOfURL:url];
    
    SAMPLE * server_receivedSound = (SAMPLE *)malloc([data length]);
    [data getBytes:server_receivedSound length:[data length]];
    int server_receivedSoundLength = [data length] / sizeof(SAMPLE);
       
    // pass this to the instrument in the main view controller
    [mainView loadRecording:server_receivedSound :server_receivedSoundLength];
    

    NSLog(@"Number of floats to play: %d", server_receivedSoundLength);
}

- (void)getNotesAtURL:(NSURL *)url
{
    NSData *data = [NSData dataWithContentsOfURL:url];
    
    recordData * server_receivedSound = (recordData *)malloc([data length]);
    [data getBytes:server_receivedSound length:[data length]];
    int server_receivedSoundLength = [data length] / sizeof(recordData);
    
    // pass this to the instrument in the main view controller
    [mainView loadNoteData:server_receivedSound :server_receivedSoundLength];

}

- (void)getRhythmAtURL:(NSURL *)url
{
    NSData *data = [NSData dataWithContentsOfURL:url];
    
    recordData * server_receivedSound = (recordData *)malloc([data length]);
    [data getBytes:server_receivedSound length:[data length]];
    int server_receivedSoundLength = [data length] / sizeof(recordData);

    // pass this to the instrument in the main view controller
    [mainView loadRhythmData:server_receivedSound :server_receivedSoundLength];
}

// on your mark
- (void)getSet:(NSURL *)chordUrl :(NSURL *)bassUrl :(NSURL *)leadUrl :(NSURL *)audio1Url :(NSURL *)audio2Url :(NSURL *)chordArtUrl :(NSURL *)bassArtUrl :(NSURL *)leadArtUrl :(NSURL *)audio1ArtUrl :(NSURL *)audio2ArtUrl
{
    /// --- First download the note and audio data ---
    // Chord Notes
    NSData *chordData = [NSData dataWithContentsOfURL:chordUrl];
    recordData * chordNotes = (recordData *)malloc([chordData length]);
    [chordData getBytes:chordNotes length:[chordData length]];
    int chordData_length = [chordData length] / sizeof(recordData);
    // Bass Notes
    NSData *bassData = [NSData dataWithContentsOfURL:bassUrl];
    recordData * bassNotes = (recordData *)malloc([bassData length]);
    [bassData getBytes:bassNotes length:[bassData length]];
    int bassData_length = [bassData length] / sizeof(recordData);
    // Lead Notes
    NSData *leadData = [NSData dataWithContentsOfURL:leadUrl];
    recordData * leadNotes = (recordData *)malloc([leadData length]);
    [leadData getBytes:leadNotes length:[leadData length]];
    int leadData_length = [leadData length] / sizeof(recordData);
    // Audio Recording
    NSData *audio1Data = [NSData dataWithContentsOfURL:audio1Url];
    SAMPLE * audio1Rec = (SAMPLE *)malloc([audio1Data length]);
    [audio1Data getBytes:audio1Rec length:[audio1Data length]];
    int audio1Data_length = [audio1Data length] / sizeof(SAMPLE);
    // Audio Recording 2
    NSData *audio2Data = [NSData dataWithContentsOfURL:audio2Url];
    SAMPLE * audio2Rec = (SAMPLE *)malloc([audio2Data length]);
    [audio1Data getBytes:audio1Rec length:[audio1Data length]];
    int audio2Data_length = [audio2Data length] / sizeof(SAMPLE);
    
    /// --- Now get the rhythm data for each track ---
    // Chord Rhythm
    NSData *artChordData = [NSData dataWithContentsOfURL:chordArtUrl];
    recordData * artChordRec = (recordData *)malloc([artChordData length]);
    [artChordData getBytes:artChordRec length:[artChordData length]];
    int artChordData_length = [artChordData length] / sizeof(recordData);
    // Bass Rhythm
    NSData *artBassData = [NSData dataWithContentsOfURL:bassArtUrl];
    recordData * artBassRec = (recordData *)malloc([artBassData length]);
    [artBassData getBytes:artBassRec length:[artBassData length]];
    int artBassData_length = [artBassData length] / sizeof(recordData);
    // Lead Rhythm
    NSData *artLeadData = [NSData dataWithContentsOfURL:leadArtUrl];
    recordData * artLeadRec = (recordData *)malloc([artLeadData length]);
    [artLeadData getBytes:artLeadRec length:[artLeadData length]];
    int artLeadData_length = [artLeadData length] / sizeof(recordData);
    // audio1 rhythm
    NSData *artAudio1Data = [NSData dataWithContentsOfURL:audio1ArtUrl];
    recordData * artAudio1Rec = (recordData *)malloc([artAudio1Data length]);
    [artAudio1Data getBytes:artAudio1Rec length:[artAudio1Data length]];
    int artAudio1Data_length = [artAudio1Data length] / sizeof(recordData);
    // audio2 rhythm
    NSData *artAudio2Data = [NSData dataWithContentsOfURL:audio2ArtUrl];
    recordData * artAudio2Rec = (recordData *)malloc([artAudio2Data length]);
    [artAudio2Data getBytes:artAudio2Rec length:[artAudio2Data length]];
    int artAudio2Data_length = [artAudio2Data length] / sizeof(recordData);
    NSLog(@"ca URL: %@", chordArtUrl); 
    NSLog(@"a1 URL: %@", audio1Url); 
    NSLog(@"a2 URL: %@", audio2Url); 

    [mainView loadSet:chordNotes :chordData_length :bassNotes :bassData_length :leadNotes :leadData_length :audio1Rec :audio1Data_length :audio2Rec :audio2Data_length :artChordRec :artChordData_length :artBassRec :artBassData_length :artLeadRec :artLeadData_length :artAudio1Rec :artAudio1Data_length :artAudio2Rec :artAudio2Data_length];
 
}

////////////// TABLE VIEW
#pragma mark - UITableViewDataSource

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    int loadType = [mainView getLoadType];
    int i = [indexPath indexAtPosition:1];  // The first index is the section, which will always be 0
    NSDictionary *soundJSON = [self.sounds objectAtIndex:i];
    NSDictionary *soundFields = [soundJSON objectForKey:@"fields"];

    if (loadType == AUDIO_REC_ONLY || loadType == NOTE_REC_ONLY || loadType == RHYTHM_ONLY){
        NSString *soundPath = [soundFields objectForKey:@"path"]; 
        NSURL *url = [NSURL URLWithString:[NSString stringWithFormat:@"%@songshare/sounds/%@", kSongShareBaseURLString, soundPath]];
    
        if (loadType == AUDIO_REC_ONLY)
            [self getSoundAtURL:url];
        else if (loadType == NOTE_REC_ONLY)
            [self getNotesAtURL:url];
        else if (loadType == RHYTHM_ONLY)
            [self getRhythmAtURL:url];
    }
    
    if (loadType == AUDIO_PLUS_RHYTHM){
        NSString *soundPath = [soundFields objectForKey:@"soundpath"]; 
        NSURL *url = [NSURL URLWithString:[NSString stringWithFormat:@"%@songshare/sounds/%@", kSongShareBaseURLString, soundPath]];
        [self getSoundAtURL:url];
        NSLog(@"URL: %@", url);   
        
        NSString *rhythmPath = [soundFields objectForKey:@"artpath"]; 
        NSURL *rhythmurl = [NSURL URLWithString:[NSString stringWithFormat:@"%@songshare/sounds/%@", kSongShareBaseURLString, rhythmPath]];
        [self getRhythmAtURL:rhythmurl];
        NSLog(@"URL: %@", rhythmurl);   
    }
    
    if (loadType == NOTE_PLUS_RHYTHM){
        NSString *soundPath = [soundFields objectForKey:@"notepath"]; 
        NSURL *url = [NSURL URLWithString:[NSString stringWithFormat:@"%@songshare/sounds/%@", kSongShareBaseURLString, soundPath]];
        [self getSoundAtURL:url];
        NSLog(@"URL: %@", url);   
        
        NSString *rhythmPath = [soundFields objectForKey:@"artpath"]; 
        NSURL *rhythmurl = [NSURL URLWithString:[NSString stringWithFormat:@"%@songshare/sounds/%@", kSongShareBaseURLString, rhythmPath]];
        [self getRhythmAtURL:rhythmurl];
        NSLog(@"URL: %@", rhythmurl);   
    }
    
    if (loadType == SONG_SET){
        NSString *chordPath = [soundFields objectForKey:@"chordpath"]; 
        NSURL *urlchord = [NSURL URLWithString:[NSString stringWithFormat:@"%@songshare/sounds/%@", kSongShareBaseURLString, chordPath]];
        NSString *bassPath = [soundFields objectForKey:@"basspath"]; 
        NSURL *urlbass = [NSURL URLWithString:[NSString stringWithFormat:@"%@songshare/sounds/%@", kSongShareBaseURLString, bassPath]];
        NSString *leadPath = [soundFields objectForKey:@"leadpath"]; 
        NSURL *urllead = [NSURL URLWithString:[NSString stringWithFormat:@"%@songshare/sounds/%@", kSongShareBaseURLString, leadPath]];
        NSString *audio1Path = [soundFields objectForKey:@"audio1path"]; 
        NSURL *urlaudio1 = [NSURL URLWithString:[NSString stringWithFormat:@"%@songshare/sounds/%@", kSongShareBaseURLString, audio1Path]];
        NSString *audio2Path = [soundFields objectForKey:@"audio2path"]; 
        NSURL *urlaudio2 = [NSURL URLWithString:[NSString stringWithFormat:@"%@songshare/sounds/%@", kSongShareBaseURLString, audio2Path]];
        // articulation data
        NSString *artChordPath = [soundFields objectForKey:@"artchordpath"]; 
        NSURL *urlartchord= [NSURL URLWithString:[NSString stringWithFormat:@"%@songshare/sounds/%@", kSongShareBaseURLString, artChordPath]];
        NSString *artBassPath = [soundFields objectForKey:@"artbasspath"]; 
        NSURL *urlartbass = [NSURL URLWithString:[NSString stringWithFormat:@"%@songshare/sounds/%@", kSongShareBaseURLString, artBassPath]];
        NSString *artLeadPath = [soundFields objectForKey:@"artleadpath"]; 
        NSURL *urlartlead = [NSURL URLWithString:[NSString stringWithFormat:@"%@songshare/sounds/%@", kSongShareBaseURLString, artLeadPath]];
        NSString *artAudio1Path = [soundFields objectForKey:@"artaudio1path"]; 
        NSURL *urlartaudio1 = [NSURL URLWithString:[NSString stringWithFormat:@"%@songshare/sounds/%@", kSongShareBaseURLString, artAudio1Path]];
        NSString *artAudio2Path = [soundFields objectForKey:@"artaudio2path"]; 
        NSURL *urlartaudio2 = [NSURL URLWithString:[NSString stringWithFormat:@"%@songshare/sounds/%@", kSongShareBaseURLString, artAudio2Path]];
        
        NSLog(@"c %@, b %@, l %@, a1 %@, a2 %@, artc %@, artb %@, artl %@, arta1 %@, arta2 %@ ", chordPath, bassPath, leadPath, audio1Path, audio2Path, artChordPath, artBassPath, artLeadPath, artAudio1Path, artAudio2Path);

        [self getSet:(NSURL *)urlchord :(NSURL *)urlbass :(NSURL *)urllead :(NSURL *)urlaudio1 :(NSURL *)urlaudio2 :(NSURL *)urlartchord :(NSURL *)urlartbass :(NSURL *)urlartlead :(NSURL *)urlartaudio1 :urlartaudio2];
    }
    
    //NSLog(@"URL: %@", url);    
    [self dismissModalViewControllerAnimated:YES];
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return [self.sounds count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *soundCellIdentifier = @"Sound";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:soundCellIdentifier];
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:soundCellIdentifier];
    }
    
    int i = [indexPath indexAtPosition:1];  // The first index is the section, which will always be 0
    
    NSDictionary *soundJSON = [self.sounds objectAtIndex:i];
    NSDictionary *soundFields = [soundJSON objectForKey:@"fields"];
    cell.textLabel.text = [soundFields objectForKey:@"name"];
    cell.detailTextLabel.text = [soundFields objectForKey:@"description"];
    
    return cell;
}

- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
    return NO;
}

/////
- (IBAction) refreshButton:(UISwitch *)sender{
    [mainView refresh];
}

- (IBAction) cancelButton:(UISwitch *)sender{
    [self dismissModalViewControllerAnimated:YES];
}

///////////

@end
