//  HellOGLESViewController.h
//  HellOGLES
//
//  Created by Ge Wang on 1/19/11.
//  Copyright 2011 Stanford University. All rights reserved.
#import "JifDefines.h"
#import <UIKit/UIKit.h>
#import <OpenGLES/EAGL.h>
#import <OpenGLES/ES1/gl.h>
#import <OpenGLES/ES1/glext.h>
@interface SSSViewController : UIViewController
//@interface SSSViewController : UIViewController
{
    EAGLContext *context;
    GLuint program;
    
    BOOL animating;
    NSInteger animationFrameInterval;
    CADisplayLink *displayLink;
    
    
    IBOutlet UISwitch* ActiveSwitchOutlet;
    IBOutlet UISwitch* PlayArtSwitchOutlet;
    //IBOutlet UIButton* recordStart;
    
    IBOutlet UITextField* nameTextOutlet;
    IBOutlet UITextField* DescriptionTextOutlet;
    
    IBOutlet UIButton* uploadButtonOutlet;
    IBOutlet UIButton* downloadButtonOutlet;
    
    IBOutlet UIButton* uploadTrackButtonOutlet;
    IBOutlet UIButton* downloadTrackButtonOutlet;
    IBOutlet UIButton* uploadRhythmButtonOutlet;
    IBOutlet UIButton* downloadRhythmButtonOutlet;
    IBOutlet UIButton* uploadSoundButtonOutlet;
    IBOutlet UIButton* downloadSoundButtonOutlet;
}

@property (readonly, nonatomic, getter=isAnimating) BOOL animating;
@property (nonatomic) NSInteger animationFrameInterval;


@property (nonatomic, retain) IBOutlet UILabel * nameLabel;
@property (nonatomic, retain) IBOutlet UILabel * descriptionLabel;

@property (strong, nonatomic) IBOutlet UITextField *nameTextField;
@property (strong, nonatomic) IBOutlet UITextField *descriptionTextField;

// store list of various things on the server
@property (strong, nonatomic) NSMutableArray *audioRecList;
@property (strong, nonatomic) NSMutableArray *noteRecList;
@property (strong, nonatomic) NSMutableArray *rhythmList;
@property (strong, nonatomic) NSMutableArray *audioTrackList;
@property (strong, nonatomic) NSMutableArray *noteTrackList;
@property (strong, nonatomic) NSMutableArray *setList;

- (void)startAnimation;
- (void)stopAnimation;

// GUI
// buttons
- (IBAction) toggleUI:(UIButton*)sender;
- (IBAction) RecordButton:(UIButton*)sender;
- (IBAction) PlayButton:(UIButton*)sender;
- (IBAction) StopButton:(UIButton*)sender;
- (IBAction) DubButton:(UIButton*)sender;
- (IBAction) ClearButton:(UIButton*)sender;
- (IBAction) goToModalTest:(UIButton *)sender;
- (IBAction) loadRec:(UIButton *)sender;
- (IBAction) loadRhythm:(UIButton *)sender;
- (IBAction) loadTrack:(UIButton *)sender;
- (IBAction) loadSection:(UIButton *)sender;
// switches
- (IBAction) ActiveSwitch:(UISwitch*)sender;
- (IBAction) PlayArticulationSwitch:(UISwitch*)sender;

// networking
- (void )refresh;
- (IBAction)uploadSound:(UIButton*)sender;
- (IBAction)downloadSound:(UIButton*)sender;
- (IBAction)uploadRhythm:(UIButton*)sender;
- (IBAction)downloadRhythm:(UIButton*)sender;
- (IBAction)uploadTrack:(UIButton*)sender;
- (IBAction)downloadTrack:(UIButton*)sender;
- (IBAction)uploadSet:(UIButton*)sender;
- (IBAction)downloadSet:(UIButton*)sender;

- (void) loadRecording:(SAMPLE* )audioData : (int) numFrames;
- (void) loadNoteData:(recordData* )noteData : (int) numFrames;
- (void) loadRhythmData:(recordData* )rhythmData : (int) numFrames;
- (void) loadSet:(recordData*)chordData : (int) numChordData : (recordData*)bassData : (int) numBassData : (recordData*)leadData : (int) numLeadData : (SAMPLE*)audio1Data : (int) numAudio1Data : (SAMPLE*)audio2Data : (int) numAudio2Data : (recordData*)artChordData  : (int) numArtChordData : (recordData*) artBassData : (int) numArtBassData : (recordData*) artLeadData : (int) numArtLeadData : (recordData*) artAudio1Data : (int) numArtAudio1Data : (recordData*) artAudio2Data : (int) numArtAudio2Data;

- (int) getLoadType;



@end
