//-----------------------------------------------------------------------------
//  name: renderer.m
//  desc: graphics + audio module for HellOGLES
//
//  author: created by Ge Wang
//  date: winter 2011
//-----------------------------------------------------------------------------
#ifndef __RENDERER_H__
#define __RENDERER_H_

#include "mo_gfx.h"
#include "MixMaster.h"
#include "Entity.h"

// initialize
bool yayInit();
// set dimensions of rendering surface
void yaySetDims( GLint width, GLint height );
// render
void yayRender();
// cleanup
void yayCleanup();

// touch handling
void touchesBegan(NSSet *touches);
void touchesMoved(NSSet *touches);
void touchesEnded(NSSet *touches);

// draw stuff
void drawWaveForm();
void drawInst();
void drawHexBackground();
PulseEntity * find_hex(Vector3D l);

// Square Instrument
int getCurrentNote();
void updateChordWeight(int currentChordDegree);
void updateNoteWeight(CHORD chord);

//----------------- GUI HANDLERS  ---------- //
// button prototypes
void Record();
void Play();
void Stop();
void Dub();
void Erase();


// switch functions
void setActive(bool on);
void setPlayArticulation(bool on);
void setHarmony(bool on);

// share data
audioRecording getAudioRecording();
audioRecording getAudioRecording(int track);
synthRecording getNoteRecording();
synthRecording getNoteRecording(int track);
artRecording getArtRecording();
artRecording getArtRecording(int track);
void loadAudioRecording(audioRecording recording);
void loadAudioRecording(int track, audioRecording recording);
void loadNoteRecording(synthRecording recording);
void loadNoteRecording(int track, synthRecording recording);
void loadArtRecording(artRecording recording);
void loadArtRecording(int track, artRecording recording);

int getCurrentTrack();

#endif
